/*
 * jQuery scrollcheckbox
 * Copyright (c) 2011 myDBR.com
 *
 * http://myDBR.com
 *
 * Depends:
 *   - jQuery
 *   - jQuery UI
*/

var divs_timeout, divs_words = [];
(function($, undefined){

$.widget("mydbr.scrollcheckbox", {
	
	// default options
	options: {
		header: true,
		height: 175,
		minWidth: 225,
		check_all: 'Check all',
		uncheck_all: 'Uncheck all',
		select_options: 'Select options',
		selected: '# selected',
		filter: 'Filter:',
		filter_text: 'Enter keywords'
	},

	_create: function() {
		var a_checkbox, scb=this, el=this.element, cell=$(el), o = this.options, 
		check_button = '<a class="ui-scrollcheckbox-all" href="#"><span class="ui-icon ui-icon-check"></span><span>'+o.check_all+'</span></a>',
		expand_button = '<a class="ui-scrollcheckbox-expand" href="#"><span class="ui-icon ui-icon-arrow-4-diag"></span><span></span></a>',		
		uncheck_button = '<a class="ui-scrollcheckbox-none" href="#"><span class="ui-icon ui-icon-closethick"></span><span>'+o.uncheck_all+'</span></a>',		
		start_button='<button type="button" class="ui-state-default ui-corner-all ui-scrollcheckbox-button" style="width: 231px; "><span class="ui-icon ui-icon-triangle-2-n-s"></span><span class="ui-scrollcheckbox-button-text">'+o.select_options+'</span></button>',
		filter_icon = $.browser.webkit ? '' : '<span class="ui-scrollcheckbox-filter-icon"></span>';
		filter = '<div class="ui-scrollcheckbox-filter">'+filter_icon+'</span><input placeholder="'+o.filter_text+'" type="search" results="0"></div>';
		
		this.speed = $.fx.speeds._default; // default speed for effects
		var noscroll= cell.hasClass('scroll_cb') ? '' : ' ui-scrollcheckbox-items-full';
		if (noscroll) expand_button='';
		cell.wrapInner('<div class="ui-scrollcheckbox-items'+noscroll+'" />');
		cell.wrapInner('<div class="ui-scrollcheckbox" />');

		if (cell.hasClass('find_scb')) {
			cell.find('.ui-scrollcheckbox').prepend('<div class="ui-scrollcheckbox-control">'+filter+'<ul><li>'+check_button+'</li><li>'+uncheck_button+'</li><li>'+expand_button+'</li></ul></div>');
		}
		if (cell.hasClass('spacesave_scb')) {
			this.startbutton = cell.prepend(start_button).find('.ui-scrollcheckbox-button');
			$(this.startbutton).click(function() {
				$(this).siblings('.ui-scrollcheckbox').slideToggle(300);
			});
		} else {
			cell.find('.ui-scrollcheckbox').css('display', 'block');
		}
		
		cell.find('.ui-scrollcheckbox-items .checkboxitem').click(function() {
			scb.set_button_text(o, this);
		});
		
		
		// Check all
		cell.find('.ui-scrollcheckbox-all').click( function() {
			$(this).parents('.ui-scrollcheckbox').find('.ui-scrollcheckbox-items .checkboxitem:not(:checked):visible').each( function() {
				$(this).attr('checked', true);
			});
			a_checkbox = $(this).parents('.ui-scrollcheckbox').find('.ui-scrollcheckbox-items .checkboxitem')[0];
			set_param_cb_value(a_checkbox);
			scb.set_button_text(o, a_checkbox);
			
			$(this).parents('.ui-scrollcheckbox').find('.optgroupcb').attr('checked', true).prop("indeterminate", false);
		});	

		// Uncheck all
		cell.find('.ui-scrollcheckbox-none').click( function() {
			$(this).parents('.ui-scrollcheckbox').find('.ui-scrollcheckbox-items .checkboxitem:checked:visible').each( function() {
				$(this).attr('checked', false);
			});
			a_checkbox = $(this).parents('.ui-scrollcheckbox').find('.ui-scrollcheckbox-items .checkboxitem')[0];
			set_param_cb_value(a_checkbox);
			scb.set_button_text(o, a_checkbox);
			$(this).parents('.ui-scrollcheckbox').find('.optgroupcb').attr('checked', false).prop("indeterminate", false);
		});	
		
		// Expand
		cell.find('.ui-scrollcheckbox-expand').click( function() {
			$(this).parents('.ui-scrollcheckbox').find('.ui-scrollcheckbox-items').toggleClass('ui-scrollcheckbox-items-full');
		});	
		
		a_checkbox = cell.find('.ui-scrollcheckbox-items .checkboxitem')[0];
		scb.set_button_text(o, a_checkbox);
		cell.find('.ui-scrollcheckbox-filter input').keyup( function() {
			scb.search(this, $(this).parents('.ui-scrollcheckbox').find('.ui-scrollcheckbox-items'), Event);
		});
		
		cell.find('.optgrouplabel').click( function() {
			scb.set_button_text(o, this);
		});
		
		cell.find('.optgroupclick').click( function() {
			scb.set_button_text(o, this);
		});
		
		// cell.find('.ui-scrollcheckbox-items').resizable({ handles: "s"});
	},
	
	set_button_text: function(o, e) {
		s = $(e).parents('.ui-scrollcheckbox-items').find('.checkboxitem:checked').length;
		$(e).parents('.ui-scrollcheckbox').siblings().find('.ui-scrollcheckbox-button-text').text(s ? o.selected.replace('#', s) : o.select_options);
	},
	
	search: function(phrase, cbs, event)
	{
		var kc = event.keyCode, 
			words = phrase.value.toLowerCase().split(" "),
			elem, i, displayStyle;


		clearTimeout(divs_timeout);
		divs_timeout = setTimeout(function(){do_search(kc);},600);


		function do_search(kcode) 
		{
			var skipthese = [9,16];

			if (words.compare(divs_words) || skipthese.in_array(kcode)) {
				return;
			}
			divs_words = words;

			// Hide / show items
			$(cbs).find('label').each( 
				function() { 
					elem = $(this).text().replace(/<[^>]+>/g,"");
					displayStyle = 'none';
					for (i = 0; i < words.length; i++) {
						if (elem.toLowerCase().indexOf(words[i])>=0)
							displayStyle = '';
						else {
							displayStyle = 'none';
							break;
						}
					}
					$(this).parent().css('display', displayStyle);
				}
			);
			// Hide / show group titles
			$(cbs).find('.optgroup').each(
				function() {
					elem = $(this).find('.optgrouplabel').text().replace(/<[^>]+>/g,"");
					for (i = 0; i < words.length; i++) {
						if (elem.toLowerCase().indexOf(words[i])>=0)
							displayStyle = 'block';
						else {
							displayStyle = 'none';
							break;
						}
					}
					// If optgroup matches the serach, display all options
					if (displayStyle=='block') {
						$(this).find(".pchecklist").css('display','');
					} else {					
						displayStyle = 'none';
						$(this).find(".pchecklist").each(
							function() {
								if ($(this).css('display')=='block') {
									displayStyle = 'block';
								}
							}
						);
					}
					$(this).find('.optgrouptitle').css('display', displayStyle);
				}
			);
			set_optgroup_state ( $(cbs).parents('.checkboxlist') );
		}
	}
	});
})(jQuery);
